package es.axa.mgSE.beans;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.richfaces.model.selection.SimpleSelection;

import es.axa.SE.filenet.tasks.TaskSEManager;
import es.axa.mgSE.hibernate.HibernateUtil;
import es.axa.mgSE.objects.Gestor;
import es.axa.mgSE.objects.ListaGestores;


public class MantGestBean {
	private List <Gestor> lGest;
	private String sortMode="single";
	private String selectionMode="multi";
	private SimpleSelection selection = new SimpleSelection();
	private String sMensaje="";

	private static final Log log = LogFactory.getLog(MantGestBean.class);
	
	public List <Gestor> getlGest() throws Exception {
		try {
			ListaGestores lgestObj=new ListaGestores();
			lGest=lgestObj.getListGestores();
			HibernateUtil.closeSession();
			return lGest;
			
		}catch (Exception e){
			HibernateUtil.closeSession();
			throw e;
		}
		
	}

	public void setlGest(List <Gestor> lGest) {
		this.lGest = lGest;
	}

	public String getSortMode() {
		return sortMode;
	}

	public void setSortMode(String sortMode) {
		this.sortMode = sortMode;
	}

	public String getSelectionMode() {
		return selectionMode;
	}

	public void setSelectionMode(String selectionMode) {
		this.selectionMode = selectionMode;
	}

	public SimpleSelection getSelection() {
		return selection;
	}
	
	public void setSelection(SimpleSelection selection) {
		this.selection = selection;
	}
	
	public void takeSelection(){
		System.out.println("Seleccin");
	}
	
	public String getsMensaje() {
		return sMensaje;
	}

	public void setsMensaje(String sMensaje) {
		this.sMensaje = sMensaje;
	}

	public void update()throws Exception {
		try{
			if (!lGest.isEmpty()) {
				log.debug("update - Iniciando update");
				
				ListaGestores lgestObj=new ListaGestores();
				
				// Obtener la lista tal y como est antes de actualizar
				List<Gestor> listaOldGest = lgestObj.getListGestores();
				
				// Actualizamos la lista con los valores introducidos por el usuario
				lgestObj.updateListGestores(lGest);
				
				// Construir la lista de gestores que pasan de activo a inactivo
				List<Gestor> gestCambiados = new ArrayList<Gestor>();
				for( int i = 0; i < listaOldGest.size(); i++) {
					if (!lGest.get(i).isPresente() && listaOldGest.get(i).isPresente()) {
						gestCambiados.add(lGest.get(i));
					}
				}
				
				//Ahora tenemos que pasar las tareas activas de los usuarios cambiados
				//a otros usuarios que estn presentes
				if (!gestCambiados.isEmpty()){
					TaskSEManager taskManager=new TaskSEManager();
					taskManager.traspasoTareasActivas(gestCambiados);
				}
					
				
				this.setsMensaje("La base de datos se ha actualizado correctamente");
				log.debug("update - Finalizando update");
			}else {
				this.setsMensaje("No hay ningn elemento en la tabla");
			}
			
		}catch (Exception e){
			throw e;
		}finally {
			HibernateUtil.closeSession();
		}
	}
	
}
